/*
 Copyright 2006 Opera Software ASA. All rights reserved.
 
This file contains Original Code and/or Contributions to the Original 
Code as defined in the Opera Web Applications License (the License). 
You may not use this file except in compliance with the License. Please 
obtain a copy of the License at http://www.opera.com/license/owal/
and read it before using this file. 

The Original Code and all Contributions to the Original Code distributed 
under the License are distributed on an AS IS basis, WITHOUT WARRANTY 
OF ANY KIND, EITHER EXPRESS OR IMPLIED, AND OPERA HEREBY DISCLAIMS ALL 
SUCH WARRANTIES, INCLUDING WITHOUT LIMITATION, ANY WARRANTIES OF 
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT. 

Please see the License for the specific language governing rights and 
limitations under the License.  
*/
OW_GenericButtons=new function()
{
  
  var createFlipButton=function(idFront, idButton, idBack, callbackfunction)
  {
    var front=document.getElementById(idFront);
    var button=document.getElementById(idButton);
    var callback=callbackfunction||null;
    var idBack=idBack;
    var idButton=idButton;

    var animation=button.createAnimation();

    animation.style.opacity=0;
    animation.speed=50;
    animation.accelerationProfile=animation.accelerate;


    animation.fadeTo=function(to)
    {
      animation.addAnimation('opacity', animation.style.opacity, to).run();
    }

    front.addEventListener
    (
      'mouseover',
      function(event)
      {
        clearTimeout(animation.timeout);
        if((event.target.id!=idButton) && (parseFloat(animation.style.opacity)<.3))
        {
          if(!animation.buttonOver)
          {
          if(animation._isrunning) animation.stop();
          animation.fadeTo(.3);
          }
        }
      },
      false
    );

    front.addEventListener
    (
      'mouseout',
      function()
      {
        animation.timeout=setTimeout(animation.fadeTo, 20, 0);
      },
      false
    );
    button.addEventListener
    (
      'mouseover',
      function()
      {
        animation.buttonOver=true;
        if(parseFloat(animation.style.opacity)!=1)
        {
          animation.fadeTo(1);
        }
      },
      false
    );
    button.addEventListener
    (
      
      'mouseout',
      function()
      {
        animation.buttonOver=false;
        animation.fadeTo(.3);
      },
      false
    );

    button.onclick=function()
    {
      front.style.display='none';
      document.getElementById(idBack).style.display='block';
      if(callback) callback();
    }
  }

  this.createGenericButtons=function(obj)
  {
    createFlipButton
    (
      obj.idFront, 
      obj.idFlipButtonFront, 
      obj.idBack, 
      obj.callBackFlipButtonFront
    );
    createFlipButton
    (
      obj.idBack, 
      obj.idFlipButtonBack, 
      obj.idFront, 
      obj.callBackFlipButtonBack
    );


  }
}
